function Form(el, data, okCallback, cancelCallback){
    let formBody = document.createElement('div')
    formBody.id = 'form-body'
    let okButton = document.createElement('button')
    okButton.innerHTML = 'OK'

    let cancelButton = document.createElement('button')
    cancelButton.innerHTML = 'Cancel'

    formBody.innerHTML = '<h2>тут будет форма</h2>'
    
    let divInputs = document.createElement('div');
    formBody.appendChild(divInputs);
    let inputCreators = {

        String(key, value, oninput){
            let input = document.createElement('input');
            let arrPass = []
            for(let char of value){
                if(char === '*'){
                    arrPass.push(char)
                }
            }
            (arrPass.length === value.length && arrPass.length >= 6) ? input.type = 'password' : input.type = 'text';
            input.placeholder = (key[0] === '*' ? key.substring(1) : key);
            input.value       = value
            input.oninput     = () => oninput(input.value)
            return input
        },
        Boolean(key, value, oninput){
            let input = document.createElement('input');
            input.checked = value;
            input.type = 'checkbox';
            input.oninput = () => oninput(input.checked)
            return input
        },
        Date(key, value, oninput){
            let input = document.createElement('input');
            input.type = 'datetime-local';
            input.placeholder = (key[0] === '*' ? key.substring(1) : key);
            let timestamp = value.getTime();
            input.value = ((new Date(timestamp - value.getTimezoneOffset() * 60 * 1000)).toISOString()).slice(0, -8);
            input.oninput = () => oninput(new Date(input.value));
            return input
        },
    }

    
    let firstdata = {...data}
    let start = (data) => {

    let arrayError = []
    for (let [key,value] of Object.entries(data)){
        
        let inputCreator = inputCreators[value.constructor.name];
        let errDiv = document.createElement('div');
        let input = inputCreator(key,value,(value) => {

            if(typeof this.validators[key] === 'function'){
                let result = this.validators[key](value, key,data, input);
                
                if (result === true){
                    errDiv.id = "";
                    errDiv.innerText ="";
                    input.style.backgroundColor = 'white';
                    data[key] = value;

                    i = arrayError.indexOf(key);
                    if(i >= 0) {
                    arrayError.splice(i,1);
                    }
                    
                } else {
                    errDiv.id = "error-div";
                    errDiv.innerText = result + ' ' + (key[0] === '*' ? key.substring(1) : key);
                    input.style.backgroundColor = 'red';

                    if (!arrayError.includes(key)){
                        arrayError.push(key);
                    }
                }
            } else {
                data[key] = value;
            }
            
            block : {   if (arrayError.length > 0){
                            okButton.disabled = true;
                            break block
                        }else{
                            okButton.disabled = false;
                        }
                        for (let [key,value] of Object.entries(data)){       ////проверка обязательных *key
                            if(key[0] === '*' && value === ''){                   ////находим первое пустое и break
                            
                            okButton.disabled = true;
                            break block
                            } else if(key[0] === '*' && value !== ''){
                                okButton.disabled = false;
                            } 
                        }
            }
        });
    
        
        if(key[0] === '*'){
            let span = document.createElement('span');
            let newKey = key.replace(/^\*(.*)/, '<span style="color:red">* </span>$1');
            
            span.innerHTML = newKey;
            divInputs.appendChild(span)                           
        } else {
            let span = document.createElement('span');
            span.innerHTML = key;
            divInputs.appendChild(span)                  
        }
        
        divInputs.appendChild(input);               
        divInputs.append(errDiv);                   
    }
    
    
}
start(data)

    if (typeof okCallback === 'function'){
        formBody.appendChild(okButton);
        okButton.onclick = (e) => {
            this.okCallback(data)
        }
    }

    if (typeof cancelCallback === 'function'){
        formBody.appendChild(cancelButton);

        cancelButton.onclick = () => {
            data = {...firstdata}
            divInputs.innerHTML = '';
            start(data)
        }
    }
    
    el.appendChild(formBody)

    this.okCallback     = okCallback
    this.cancelCallback = cancelCallback

    this.data           = data
    this.validators     = {}

}
    

let form = new Form(formContainer, {
    '*name': 'Ana',
    surname: 'Sky',
    '*password': '******',
    married : true,
    birthday: new Date((new Date).getTime() - 82800000 * 30*365)
}, () => console.log('ok'),() => console.log('cancel') )

form.okCallback = (data) => console.log(data)

form.validators['*name'] = (value, key, data, input) => value.length > 2 && 
                                                     value[0].toUpperCase() == value[0] &&
                                                    !value.includes(' ') ? true : 'Wrong';
                                                    
form.validators.surname = (value, key, data, input) => value.length > 2 && 
                                                    value[0].toUpperCase() == value[0] &&
                                                   !value.includes(' ') ? true : 'Wrong';
form.validators.birthday = (value, key, data, input) => !isNaN(value) ? true : 'Wrong';
form.validators['*password'] = (value, key, data, input) => value.length >= 6 && !value.includes(' ') ? true : 'Wrong'

console.log(form)
